"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = load;
Object.defineProperty(exports, "IKeywordShortcode", {
  enumerable: true,
  get: function get() {
    return _main.IKeywordShortcode;
  }
});

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.search");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var _main = require("../assrock-mo/main");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var getConfig = function getConfig() {
  try {
    var configs = require("../../../../../config.json");

    return configs;
  } catch (ex) {
    throw "config.json not found";
  }
};

function load(_x, _x2) {
  return _load.apply(this, arguments);
} // {"success":true,"uid":"*5QADM","shortcode":"1901","keyword":"TIPS"}%  
// curl "http://w1.mozzi.com/spa-api/?country=gh&device=smart&slug=18plus-oc2sms&action=oc2sms"


function _load() {
  _load = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(window, maybeConfig) {
    var keyword, shortcode, config, _ref, host, country, slug, offer, rockmanId, search, result;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(!!maybeConfig && maybeConfig.tag == "keywordAndShortCode")) {
              _context.next = 5;
              break;
            }

            keyword = maybeConfig.keyword, shortcode = maybeConfig.shortcode;
            return _context.abrupt("return", {
              keyword: keyword,
              shortcode: shortcode
            });

          case 5:
            config = !maybeConfig ? {
              offer: window.pac_analytics.visitor.offer
            } : maybeConfig;
            _ref = !config.host || !config.slug || !config.country ? _objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, getConfig()) : config, host = _ref.host, country = _ref.country, slug = _ref.slug, offer = _ref.offer;
            rockmanId = window.pac_analytics.visitor.rockmanId;
            search = window.location.search.substr(1) || '';
            _context.next = 11;
            return fetch("https://".concat(host, "/tallyman/v1/?action=oc2sms&country=").concat(country, "&slug=").concat(slug, "&offerId=").concat(offer, "&device=smart&rockman_id=").concat(rockmanId, "&").concat(search)).then(function (x) {
              return x.json();
            });

          case 11:
            result = _context.sent;

            if (result.success) {
              _context.next = 16;
              break;
            }

            throw result.message;

          case 16:
            return _context.abrupt("return", {
              keyword: "".concat(result.keyword, " ").concat(result.uid),
              shortcode: result.shortcode
            });

          case 17:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _load.apply(this, arguments);
}