import * as React from "react";
import { ITracker } from "../../pacman/record";
import { IFlow } from "../super-strategy/HOC";
declare type IState = "NothingYet";
declare type IActions = {
    onClick: () => void;
    clickLink: any;
};
declare type ACompType = React.ComponentType<{
    children: React.ReactNode;
} & React.HTMLAttributes<HTMLAnchorElement>>;
export declare type HOCProps = {
    currentState: IState;
    actions: IActions;
    ClickLink: ACompType;
    strategyConfig?: IFlow;
    clickUrl?: string;
    trackAdvanceInflow?: () => void;
};
export declare type IConfig = {
    host?: string;
    country?: string;
    slug?: string;
    queryString?: Array<[string, string]>;
};
export interface ILinkExtraParams {
    [key: string]: string;
}
export declare function match<R>(matcher: {
    nothingYet: () => R;
}): (state: IState) => JSX.Element | R;
declare const _default: (tracker: ITracker, maybeConfig: IConfig, Comp: React.ComponentType<HOCProps>, extraParams?: ILinkExtraParams, strategy?: IFlow) => (initState: IState) => {
    new (props: Readonly<any>): {
        state: {
            current: "NothingYet";
            redirectUrl: any;
        };
        actions: IActions;
        componentDidMount(): void;
        render(): JSX.Element;
        context: any;
        setState<K extends "current" | "redirectUrl">(state: {
            current: IState;
            redirectUrl: string | null;
        } | ((prevState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>, props: Readonly<any>) => {
            current: IState;
            redirectUrl: string | null;
        } | Pick<{
            current: IState;
            redirectUrl: string | null;
        }, K>) | Pick<{
            current: IState;
            redirectUrl: string | null;
        }, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<any> & Readonly<{
            children?: React.ReactNode;
        }>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<any>, nextState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<any>, prevState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>): any;
        componentDidUpdate?(prevProps: Readonly<any>, prevState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>, nextContext: any): void;
    };
    new (props: any, context?: any): {
        state: {
            current: "NothingYet";
            redirectUrl: any;
        };
        actions: IActions;
        componentDidMount(): void;
        render(): JSX.Element;
        context: any;
        setState<K extends "current" | "redirectUrl">(state: {
            current: IState;
            redirectUrl: string | null;
        } | ((prevState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>, props: Readonly<any>) => {
            current: IState;
            redirectUrl: string | null;
        } | Pick<{
            current: IState;
            redirectUrl: string | null;
        }, K>) | Pick<{
            current: IState;
            redirectUrl: string | null;
        }, K>, callback?: () => void): void;
        forceUpdate(callback?: () => void): void;
        readonly props: Readonly<any> & Readonly<{
            children?: React.ReactNode;
        }>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        shouldComponentUpdate?(nextProps: Readonly<any>, nextState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<any>, prevState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>): any;
        componentDidUpdate?(prevProps: Readonly<any>, prevState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>, snapshot?: any): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<any>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<any>, nextState: Readonly<{
            current: IState;
            redirectUrl: string | null;
        }>, nextContext: any): void;
    };
    contextType?: React.Context<any>;
};
export default _default;
export declare const initialState: IState;
