import React from "react";
declare type Maybe<T> = {
    tag: "Nothing";
} | {
    tag: "Just";
    value: T;
};
export declare class Experiment extends React.PureComponent<{
    loader: string;
}, {
    variant: Maybe<string>;
}> {
    static defaultProps: {
        loader: string;
    };
    state: {
        variant: Maybe<string>;
    };
    componentWillMount(): void;
    componentDidMount(): void;
    render(): JSX.Element;
}
export declare function Loader(props: {
    children?: React.ReactNode;
}): JSX.Element;
export declare class Variant extends React.Component<{
    id: string;
}> {
    render(): JSX.Element;
}
declare const _default: {
    Experiment: typeof Experiment;
    Variant: typeof Variant;
};
export default _default;
