import { IFlow } from "../super-strategy/HOC";
export declare type IKeywordShortcode = {
    keyword: string;
    shortcode: string;
    operator?: string;
};
declare type Config = {
    host?: string;
    country?: string;
    slug?: string;
    automaticallySubmitAllOperators?: boolean;
    operators?: string[];
};
export declare type IConfig = {
    tag: "tallyman";
} & Config | {
    tag: "keywordAndShortCode";
} & IKeywordShortcode | {
    tag: "keyword";
} & Config;
export declare type SingleSubmissionResult = IKeywordShortcode & {
    type: "SingleSubmissionResult";
};
export declare type MultiOperatorSubmissionResult = {
    type: "MultiOperatorSubmissionResult";
    data: Array<IKeywordShortcode>;
};
export default function load(window: Window, maybeConfig: IConfig, keyword?: string, shortcode?: string, strategy?: IFlow): Promise<SingleSubmissionResult | MultiOperatorSubmissionResult>;
export declare function load1(window: Window, maybeConfig: IConfig, keyword?: string, shortcode?: string, strategy?: IFlow): Promise<SingleSubmissionResult | MultiOperatorSubmissionResult>;
export declare function checkSubscription(window: Window, maybeConfig: IConfig, strategy?: IFlow): Promise<string>;
export {};
