"use strict";

require("core-js/modules/es6.regexp.match");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.match = match;
exports.default = exports.mockedCompletedState = exports.mockedSubscribeState = exports.initialState = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.object.assign");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.reflect.construct");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.object.to-string");

require("regenerator-runtime/runtime");

var React = _interopRequireWildcard(require("react"));

var RDS = _interopRequireWildcard(require("../../common-types/RemoteDataState"));

var _main = _interopRequireDefault(require("./main"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var initialState = {
  type: "IDENTIFY",
  result: RDS.NothingYet()
};
exports.initialState = initialState;
var mockedSubscribeState = {
  type: "SUBSCRIBE",
  result: RDS.NothingYet()
};
exports.mockedSubscribeState = mockedSubscribeState;
var mockedCompletedState = {
  type: "SUBSCRIBE",
  result: RDS.Success({
    product_url: 'https://www.yahoo.com/'
  })
};
exports.mockedCompletedState = mockedCompletedState;

function match(_ref) {
  var identify = _ref.identify,
      subscribe = _ref.subscribe;
  return function (state) {
    switch (state.type) {
      case 'IDENTIFY':
        return identify(state.result);

      case 'SUBSCRIBE':
        return subscribe(state.result);
    }
  };
}

var _default = function _default(tracker, maybeConfig, Comp, extraParams, strategy) {
  return function (initialState, isMocked) {
    var _temp;

    var HOC = (_temp = /*#__PURE__*/function (_React$PureComponent) {
      _inherits(HOC, _React$PureComponent);

      var _super = _createSuper(HOC);

      function HOC(props) {
        var _this;

        _classCallCheck(this, HOC);

        _this = _super.call(this, props);

        _defineProperty(_assertThisInitialized(_this), "state", void 0);

        var self = _assertThisInitialized(_this);

        _this.state = {
          currentState: initialState,
          actions: {
            identifyAction: function () {
              var _identifyAction = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                var _yield$getRedirectUrl, subscription_url, redirect_url, action, errorType;

                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                  while (1) {
                    switch (_context2.prev = _context2.next) {
                      case 0:
                        _context2.prev = 0;
                        self.setState({
                          currentState: {
                            type: "IDENTIFY",
                            result: RDS.Loading()
                          }
                        });
                        _context2.next = 4;
                        return (0, _main.default)(maybeConfig || {}, extraParams, strategy);

                      case 4:
                        _yield$getRedirectUrl = _context2.sent;
                        subscription_url = _yield$getRedirectUrl.subscription_url;
                        redirect_url = _yield$getRedirectUrl.redirect_url;
                        action = _yield$getRedirectUrl.action;

                        if (redirect_url) {
                          tracker.customEvent('Flow', 'advance-auto', 'redirect-success', {
                            redirect_url: redirect_url
                          });
                          self.setState({
                            currentState: {
                              type: "IDENTIFY",
                              result: RDS.Success({
                                redirect_url: redirect_url
                              })
                            },
                            redirect_url: redirect_url
                          });
                        } else {
                          tracker.customEvent('Flow', 'advance-auto', 'identify-success', {
                            subscription_url: subscription_url
                          });
                          self.setState({
                            currentState: {
                              type: "SUBSCRIBE",
                              result: RDS.NothingYet()
                            },
                            actions: _objectSpread(_objectSpread({}, self.state.actions), {}, {
                              subscribeAction: function () {
                                var _subscribeAction = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                                  var productUrl, errorType;
                                  return regeneratorRuntime.wrap(function _callee$(_context) {
                                    while (1) {
                                      switch (_context.prev = _context.next) {
                                        case 0:
                                          self.setState({
                                            currentState: {
                                              type: "SUBSCRIBE",
                                              result: RDS.Loading()
                                            }
                                          });
                                          _context.prev = 1;
                                          tracker.advancedInFlow('tallyman.v1-one-click', 'click-subscribe');
                                          _context.next = 5;
                                          return action();

                                        case 5:
                                          productUrl = _context.sent;
                                          self.setState({
                                            currentState: {
                                              type: "SUBSCRIBE",
                                              result: RDS.Success({
                                                productUrl: productUrl
                                              })
                                            },
                                            productUrl: productUrl
                                          });
                                          tracker.advancedInFlow('tallyman.v1-one-click', 'click-subscribe-success', {
                                            product_url: productUrl
                                          });
                                          _context.next = 17;
                                          break;

                                        case 10:
                                          _context.prev = 10;
                                          _context.t0 = _context["catch"](1);
                                          console.error(_context.t0);
                                          errorType = "SubscriptionError" === _context.t0.type ? "SubscriptionError" : "UnknownError";
                                          tracker.recedeInFlow('tallyman.v1-one-click', 'click-subscribe-failure', {
                                            error: _context.t0.toString()
                                          });
                                          self.setState({
                                            currentState: {
                                              type: "SUBSCRIBE",
                                              result: RDS.Failure("IError")
                                            }
                                          });
                                          self.setState({
                                            currentState: {
                                              type: "SUBSCRIBE",
                                              result: RDS.Failure({
                                                errorType: errorType,
                                                error: _context.t0
                                              })
                                            }
                                          });

                                        case 17:
                                        case "end":
                                          return _context.stop();
                                      }
                                    }
                                  }, _callee, null, [[1, 10]]);
                                }));

                                function subscribeAction() {
                                  return _subscribeAction.apply(this, arguments);
                                }

                                return subscribeAction;
                              }()
                            })
                          });
                        }

                        _context2.next = 17;
                        break;

                      case 11:
                        _context2.prev = 11;
                        _context2.t0 = _context2["catch"](0);
                        console.error(_context2.t0);
                        errorType = "NotOn3g" === _context2.t0.type ? "NotOn3g" : "UnknownError";
                        tracker.customEvent('Flow', 'recede-auto', 'identify-failure', {
                          error: _context2.t0.toString(),
                          errorType: errorType
                        });

                        _this.setState({
                          currentState: {
                            type: "IDENTIFY",
                            result: RDS.Failure({
                              errorType: errorType,
                              error: _context2.t0
                            })
                          }
                        });

                      case 17:
                      case "end":
                        return _context2.stop();
                    }
                  }
                }, _callee2, null, [[0, 11]]);
              }));

              function identifyAction() {
                return _identifyAction.apply(this, arguments);
              }

              return identifyAction;
            }()
          },
          product_url: "",
          redirect_url: ""
        };
        return _this;
      }

      _createClass(HOC, [{
        key: "UNSAFE_componentWillMount",
        value: function () {
          var _UNSAFE_componentWillMount = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
            return regeneratorRuntime.wrap(function _callee3$(_context3) {
              while (1) {
                switch (_context3.prev = _context3.next) {
                  case 0:
                    _context3.t0 = !isMocked;

                    if (!_context3.t0) {
                      _context3.next = 4;
                      break;
                    }

                    _context3.next = 4;
                    return this.state.actions.identifyAction();

                  case 4:
                  case "end":
                    return _context3.stop();
                }
              }
            }, _callee3, this);
          }));

          function UNSAFE_componentWillMount() {
            return _UNSAFE_componentWillMount.apply(this, arguments);
          }

          return UNSAFE_componentWillMount;
        }()
      }, {
        key: "componentDidUpdate",
        value: function componentDidUpdate() {
          if (this.state.is_clicked && this.state.redirect_url !== "") {
            window.location.href = this.state.redirect_url;
          }
        }
      }, {
        key: "render",
        value: function render() {
          var _this2 = this;

          var self = this;

          var productLink = function productLink(_ref2) {
            var children = _ref2.children,
                props = _objectWithoutProperties(_ref2, ["children"]);

            return /*#__PURE__*/React.createElement("a", _extends({}, props, {
              onClick: function onClick() {
                tracker.advancedInFlow('tallyman.v1-one-click', 'click-product-url', {
                  product_url: self.state.product_url
                });
                !!props.onClick ? props.onClick.apply(props, arguments) : void 6;
              },
              href: self.state.product_url
            }), children);
          };

          var redirectLink = function redirectLink(_ref3) {
            var children = _ref3.children,
                props = _objectWithoutProperties(_ref3, ["children"]);

            return /*#__PURE__*/React.createElement("a", _extends({}, props, {
              onClick: function onClick() {
                tracker.advancedInFlow('tallyman.v1-one-click', 'click-redirect-url', {
                  redirect_url: self.state.redirect_url
                });

                _this2.setState({
                  is_clicked: true
                });

                !!props.onClick ? props.onClick.apply(props, arguments) : void 6;
              },
              href: self.state.redirect_url || null
            }), children);
          };

          return /*#__PURE__*/React.createElement(Comp, _extends({
            actions: self.state.actions,
            ProductLink: productLink,
            RedirectLink: redirectLink,
            currentState: self.state.currentState,
            strategyConfig: strategy ? strategy : undefined
          }, this.props));
        }
      }]);

      return HOC;
    }(React.PureComponent), _temp);
    HOC.prototype['_client'] = "tallyman.v1-one-click";
    return HOC;
  };
};

exports.default = _default;