"use strict";

require("core-js/modules/es6.regexp.match");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.match = match;
exports.mkTolaError = exports.Success = void 0;

function match(_ref) {
  var success = _ref.success;
  return function (model) {
    switch (model.type) {
      case "Success":
        return success();
    }
  };
} // export const Waiting = <E>(): TolaResult<E> => ({ type: "Waiting" });


var Success = function Success() {
  return {
    type: "Success"
  };
};

exports.Success = Success;

var mkTolaError = function mkTolaError(type, error) {
  return {
    type: type,
    error: error
  };
};

exports.mkTolaError = mkTolaError;