"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/es7.object.values");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var path = _interopRequireWildcard(require("path"));

var fs = _interopRequireWildcard(require("fs"));

var R = _interopRequireWildcard(require("ramda"));

var _inquirer = _interopRequireDefault(require("inquirer"));

var envfile = _interopRequireWildcard(require("envfile"));

var _axios = _interopRequireDefault(require("axios"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var env = envfile.parseFileSync(path.resolve("", '.env'));
var extraConfigInfo = {
  pinScenario: null,
  pinService: null,
  oneClickScenario: null,
  oneClickService: null,
  moScenario: null,
  moService: null,
  click2smsScenario: null,
  click2smsService: null,
  moRedirScenario: null,
  moRedirService: null
};

function _default(_x) {
  return _ref.apply(this, arguments);
}

function _ref() {
  _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(page_type) {
    var result, data, countries, _yield$inquirer$promp, country, stategies, _yield$inquirer$promp2, strategy, strategyConfigs, configString, _yield$inquirer$promp3, scenariosConfig, newExtraConfigObj, extraConfigKeyArr, defaultFlow, operators, operatorsArr, updatedEnvContent, configObj;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _axios.default)({
              url: 'http://c1.ouisys.com/api/v1/get-strategies-config',
              //url:'http://localhost:3030/api/v1/get-page-legals',
              method: 'get'
            });

          case 2:
            result = _context.sent;
            data = result.data;
            countries = R.pipe(R.map(function (o) {
              return o.country;
            }), R.uniq, R.sortBy(function (x) {
              return x;
            }), function (xs) {
              return (!!env.country ? [env.country] : []).concat(xs);
            })(data);
            console.log("You are configuring '".concat(page_type, "' template.")); // first choose a country

            _context.next = 8;
            return _inquirer.default.prompt([{
              type: "list",
              name: "country",
              message: "First select a country. ".concat(env.country ? "Current country: ".concat(env.country) : ''),
              choices: countries.map(function (c) {
                return {
                  name: c,
                  value: c
                };
              })
            }]);

          case 8:
            _yield$inquirer$promp = _context.sent;
            country = _yield$inquirer$promp.country;
            stategies = R.pipe(R.filter(function (x) {
              return x.country == country;
            }), R.map(function (o) {
              return o.strategy;
            }), R.uniq, R.sortBy(function (x) {
              return x;
            }))(data);
            _context.next = 13;
            return _inquirer.default.prompt([{
              type: "list",
              name: "strategy",
              message: "Now select a strategy for ".concat(country),
              choices: stategies.map(function (s) {
                return {
                  name: s,
                  value: s
                };
              })
            }]);

          case 13:
            _yield$inquirer$promp2 = _context.sent;
            strategy = _yield$inquirer$promp2.strategy;
            strategyConfigs = R.pipe(R.filter(function (x) {
              return x.country == country && x.strategy == strategy;
            }), R.map(function (o) {
              return o;
            }))(data);

            configString = function configString(s) {
              var operators = s.scenario_config.operators;
              var operatorsArray = Object.keys(operators);
              return operatorsArray.map(function (o, i) {
                extraConfigInfo["".concat(operators[o].flow, "Scenario")] = operators[o].flowConfig.slug;
                extraConfigInfo["".concat(operators[o].flow, "Service")] = operators[o].flowConfig.service;
                return "".concat(i != 0 ? "| " : "", "OPERATOR:").concat(o, " FLOW: ").concat(operators[o].flow.toUpperCase(), " => SCENARIO: ").concat(operators[o].flowConfig.slug, " SERVICE: ").concat(operators[o].flowConfig.service, "}");
              });
            };

            _context.next = 19;
            return _inquirer.default.prompt([{
              type: "list",
              name: "scenariosConfig",
              message: "Now select scenarios for the strategy ".concat(strategy),
              choices: strategyConfigs.map(function (s) {
                return {
                  name: "".concat(strategy, " [").concat(configString(s), "]"),
                  value: s
                };
              })
            }]);

          case 19:
            _yield$inquirer$promp3 = _context.sent;
            scenariosConfig = _yield$inquirer$promp3.scenariosConfig;
            newExtraConfigObj = {};
            extraConfigKeyArr = Object.keys(extraConfigInfo);
            extraConfigKeyArr.filter(function (k) {
              return extraConfigInfo[k] !== null;
            }).map(function (e) {
              return newExtraConfigObj[e] = extraConfigInfo[e];
            });
            defaultFlow = scenariosConfig.scenario_config;
            operators = scenariosConfig.scenario_config.operators;
            operatorsArr = Object.values(operators);
            operatorsArr.map(function (obj) {
              var flowConfig = obj.flowConfig;
              newExtraConfigObj["".concat(obj.flow, "Scenario")] = flowConfig.slug;
              newExtraConfigObj["".concat(obj.flow, "Service")] = flowConfig.service;
              newExtraConfigObj["".concat(defaultFlow.default.flow, "Scenario")] = defaultFlow.default.flowConfig.slug;
              newExtraConfigObj["".concat(defaultFlow.default.flow, "Service")] = defaultFlow.default.flowConfig.service;
              newExtraConfigObj["defaultScenario"] = defaultFlow.default.flowConfig.slug;
              newExtraConfigObj["defaultService"] = defaultFlow.default.flowConfig.service;
            }); //clean env of scenarios we dont need

            extraConfigKeyArr.map(function (e) {
              console.log("EEE", e);
              delete env[e];
            });
            updatedEnvContent = envfile.stringifySync(_objectSpread(_objectSpread(_objectSpread({}, env), newExtraConfigObj), {}, {
              country: country,
              strategy: strategy,
              scenariosConfig: scenariosConfig.scenario_config_name
            }));
            configObj = {
              strategy: strategy,
              country: country,
              strategyConfigs: scenariosConfig.scenario_config
            };
            fs.writeFileSync(path.resolve("", "config.json"), JSON.stringify(configObj, null, 2), "utf8");
            fs.writeFileSync(path.resolve("", ".env"), updatedEnvContent, "utf8");

          case 33:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _ref.apply(this, arguments);
}