"use strict";

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

require("regenerator-runtime/runtime");

var _reactIntlTranslationsManager = _interopRequireDefault(require("react-intl-translations-manager"));

var _path = _interopRequireDefault(require("path"));

var _child_process = require("child_process");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var execute = function execute(command, callback) {
  (0, _child_process.exec)(command, function (error, stdout, stderr) {
    return callback(stdout);
  });
};

execute("echo \"{}\" > ./src/localization/translations/en.json", /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(res) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            (0, _reactIntlTranslationsManager.default)({
              messagesDirectory: 'src/localization/extractedMessages',
              translationsDirectory: 'src/localization/translations',
              languages: ['en'],
              // any language you need
              singleMessagesFile: true
            });
            console.log("\uD83D\uDE07 Messages extracted to  ".concat(_path.default.resolve("", "src/localization/translations/en.json")));

          case 2:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}()); // manageTranslations({
//   messagesDirectory: 'src/localization/extractedMessages',
//   translationsDirectory: 'src/localization/translations',
//   languages: ['en'], // any language you need
//   singleMessagesFile: true
// });