"use strict";

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

require("regenerator-runtime/runtime");

var _child_process = require("child_process");

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var execute = function execute(command, callback) {
  (0, _child_process.exec)(command, function (error, stdout, stderr) {
    return callback(stdout);
  });
};

var publish = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            execute("yarn build", function (name) {
              console.log("yarn build");
              execute("git config --global user.name", function (name) {
                console.log("git commit -m \"New publish\"");
                execute("git commit -m \"New publish\"", function (name) {
                  console.log("npm version patch");
                  execute("npm version patch", function (name) {
                    execute("npm publish", function (name) {
                      console.log("npm publish");
                      execute("git push", function (name) {
                        console.log("git push");
                        execute("git push --tags", function (name) {
                          console.log("git push --tags");
                        });
                      });
                    });
                  });
                });
              });
            });

          case 1:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function publish() {
    return _ref.apply(this, arguments);
  };
}();

publish();