import path from "path";
import * as envfile from "envfile";
import getScenarioLegal from "./get-scenario-legals";
import getStrategyLegals from "./get-strategy-legals";
const env = envfile.parseFileSync(path.resolve("", ".env"));

const { country, service, scenario } = env;

if(scenario){
  getScenarioLegal();
}else{
  getStrategyLegals();
}