import { IFlow } from "../super-strategy/HOC";
export declare type IConfig = {
    host?: string;
    country?: string;
    slug?: string;
    offer: number;
};
export declare type IResult = {
    finalUrl?: string;
    isValid: boolean;
    errorText?: string;
    errorType?: string;
    submissionId?: string;
};
export interface IHash {
    [key: string]: string;
}
export default function submitMSISDN(window: Window, maybeConfig: IConfig, msisdn: string, strategy?: IFlow, extraParams?: IHash): Promise<(pin: string) => Promise<string>>;
