"use strict";

require("core-js/modules/es6.regexp.match");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.match = match;
exports.initialState = exports.default = void 0;

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.reflect.construct");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.regexp.split");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.search");

var React = _interopRequireWildcard(require("react"));

var _queryString = require("../../pacman/queryString");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getConfig = function getConfig() {
  try {
    var configs = require("../../../../../config.json");

    return configs;
  } catch (ex) {
    throw "config.json not found";
  }
};

var getOrOverrideConfig = function getOrOverrideConfig(maybeConfig, strategy) {
  var config = strategy ? _objectSpread({}, strategy.flowConfig) : !maybeConfig ? {} : maybeConfig;

  var _getConfig = getConfig(),
      host = _getConfig.host,
      country = _getConfig.country,
      slug = _getConfig.slug,
      queryString = _getConfig.queryString;

  return {
    host: config.host || host,
    slug: config.slug || slug,
    country: config.country || country,
    queryString: (config.queryString || []).concat(queryString || [])
  };
};

var getRedirectUrl = function getRedirectUrl(maybeConfig, extraParams, strategy) {
  if (typeof window == "undefined") {
    return "javascript: console.error('SSR'); void 6";
  } else {
    var _getOrOverrideConfig = getOrOverrideConfig(maybeConfig, strategy),
        host = _getOrOverrideConfig.host,
        country = _getOrOverrideConfig.country,
        slug = _getOrOverrideConfig.slug,
        queryString = _getOrOverrideConfig.queryString;

    var bupperizeCountry = function bupperizeCountry(c) {
      return c == 'gb' ? 'uk' : c;
    };

    var offer = window.pac_analytics.visitor.offer;
    var s = window.location.search.substr(1);
    var search = (!!s && s.length > 0 ? [s] : []).concat((queryString || []).map(function (_ref) {
      var _ref2 = _slicedToArray(_ref, 2),
          k = _ref2[0],
          v = _ref2[1];

      return "".concat(k, "=").concat(v);
    })).join('&');
    var extraParamsQs = !extraParams ? '' : '&' + Object.keys(extraParams).map(function (k) {
      return "".concat(k, "=").concat(extraParams[k]);
    }).join('&'); // one click flow must use http not https

    var xcid = window.location.href.split("/")[3].split('?')[0];
    return "http://".concat(host, "/").concat(bupperizeCountry(country), "/").concat(slug, "?offer=").concat(offer, "&atmobirun=1&rockman_id=").concat(window.pac_analytics.visitor.rockmanId, "&redirPixels=").concat(window.location.host, "&x-xcid=").concat(xcid).concat(extraParamsQs, "&").concat(search);
  }
};

function match(matcher) {
  return function (state) {
    return state == "NothingYet" ? matcher.nothingYet() : /*#__PURE__*/React.createElement("div", null, "...");
  };
}

var _default = function _default(tracker, maybeConfig, Comp, extraParams, strategy) {
  return function (initState) {
    var _temp;

    var HOC = (_temp = /*#__PURE__*/function (_React$PureComponent) {
      _inherits(HOC, _React$PureComponent);

      var _super = _createSuper(HOC);

      function HOC() {
        var _this;

        _classCallCheck(this, HOC);

        for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this = _super.call.apply(_super, [this].concat(args));

        _defineProperty(_assertThisInitialized(_this), "state", {
          current: initState,
          redirectUrl: null
        });

        _defineProperty(_assertThisInitialized(_this), "actions", {
          onClick: function onClick() {
            var url = _this.state.redirectUrl;
            tracker.advancedInFlow('bupper-one-click', 'click', {
              url: url
            });
            window.location.href = url;
          },
          clickLink: null
        });

        return _this;
      }

      _createClass(HOC, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          var _this2 = this;

          this.setState({
            redirectUrl: getRedirectUrl(maybeConfig || {}, extraParams, strategy)
          }); // empello token for UK (GB)

          var config = getOrOverrideConfig(maybeConfig, strategy);

          if ("gb" == config.country || "uk" == config.country) {
            // add empello script in the UK
            var script = document.createElement("script");
            script.src = "//antifraud.empello.net/sngmnmct/lgdfxglz-live.js";
            document.body.append(script);

            var checkEmpello = function checkEmpello() {
              return setTimeout(function () {
                if (typeof window["Empello"] == "undefined") {
                  return checkEmpello();
                } else {
                  window["Empello"].getToken(function (token) {
                    console.log("empello token", token);
                    var url = (0, _queryString.updateUrlParameter)(getRedirectUrl(maybeConfig || {}, extraParams, strategy), "empello_token", token);

                    _this2.setState({
                      redirectUrl: url
                    });
                  });
                }
              }, 300);
            };

            checkEmpello(); //
          }
        }
      }, {
        key: "render",
        value: function render() {
          var self = this;
          var url = this.state.redirectUrl;

          var clickLink = function clickLink(_ref3) {
            var children = _ref3.children,
                props = _objectWithoutProperties(_ref3, ["children"]);

            return /*#__PURE__*/React.createElement("a", _extends({}, props, {
              onClick: function onClick() {
                tracker.advancedInFlow('bupper-one-click', 'click', {
                  url: url
                });
                !!props.onClick ? props.onClick.apply(props, arguments) : void 6;
              },
              href: url
            }), children);
          };

          self.actions.clickLink = clickLink;
          return /*#__PURE__*/React.createElement(Comp, _extends({
            actions: self.actions,
            currentState: self.state.current,
            ClickLink: self.actions.clickLink,
            strategyConfig: strategy ? strategy : undefined,
            clickUrl: url,
            trackAdvanceInflow: function trackAdvanceInflow() {
              return tracker.advancedInFlow('bupper-one-click', 'click', {
                url: url
              });
            }
          }, this.props));
        }
      }]);

      return HOC;
    }(React.PureComponent), _temp);
    HOC.prototype['_client'] = "bupper-one-click";
    return HOC;
  };
};

exports.default = _default;
var initialState = "NothingYet";
exports.initialState = initialState;