import * as React from "react";
export interface IHash {
    [key: string]: string;
}
export declare function IntlProvider({ locale, messages, children }: {
    locale: string;
    messages: IHash;
    children: React.ReactChild | JSX.Element[] | JSX.Element;
}): JSX.Element;
export declare function Translate({ id, values, defaultMessage }: {
    id: string;
    values?: object;
    defaultMessage?: string;
}): string;
export declare function injectIntl(Child: React.ComponentType<any>): (props: any) => JSX.Element;
export declare function defineMessages(messageDescriptors: any): any;
