/// <reference types="react" />
declare type Legals = {
    id: number;
    country: string;
    service: string;
    scenario: string;
    language: string;
    top_legal: string;
    price_point: string;
    disclaimer: string;
    date_created: string;
    extra_disclaimer: string;
    flow?: string;
};
declare type ILegalProps = {
    locale: string;
    legals: Array<Legals>;
    className?: string;
    flow?: string;
};
declare const _default: ({ locale, className, legals, flow }: ILegalProps) => JSX.Element;
export default _default;
