export declare type IConfig = {
    host?: string;
    country?: string;
    handle?: string;
    offer: number;
};
export interface IHash {
    [key: string]: string;
}
export interface IActions {
    submitMSISDN: (window: Window, config: IConfig, msisdn: string, operator?: string, extraParams?: IHash, bupperNumber?: string) => any;
    selectOperator: (operator: string, msisdn?: string) => void;
    backToStart: () => void;
}
