"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = submitMSISDN;
exports.submitMSISDNWithConfig = submitMSISDNWithConfig;
exports.getRedirectUrl = exports.additionalQueryString = void 0;

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.regexp.match");

require("core-js/modules/es6.regexp.replace");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("core-js/modules/es6.regexp.search");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// import { submitMSISDNWithConfig as tallymanSubmitMSISDNWithConfig} from "../tallyman.v1-mo/main"
// &msisdn%5B0%5D=506541284
var additionalQueryString = "msisdnSubmitted=Y&legalCheckbox=Y&incentivizedCheckbox=Y&op_confirmCheckbox=N";
exports.additionalQueryString = additionalQueryString;

var getConfig = function getConfig() {
  try {
    var configs = require("../../../../../config.json");

    return configs;
  } catch (ex) {
    throw "config.json not found";
  }
};

function submitMSISDN(_x, _x2, _x3, _x4, _x5, _x6) {
  return _submitMSISDN.apply(this, arguments);
} // export async function submitMSISDNWithConfig(window: Window, config: IConfig, internationalMSISDN: string, bupperMSISDN: string, extraParams?: { [key: string]: string }): Promise<string> {
//   const { slug, country, device, offer, host } = config
//   const search = window.location.search.length > 1 ? ('&' + window.location.search.substr(1)) : ''
//   const extraParamsQs = !extraParams ? '' : '&' + Object.keys(extraParams).map(k => `${k}=${extraParams[k]}`).join('&')
//   const rockmanId = window.pac_analytics.visitor.rockmanId
//   //await tallymanSubmitMSISDNWithConfig(window, config, internationalMSISDN, extraParams);
//   return `https://${host}/${country}/${slug}?offer=${offer}&device=${device}&rockman_id=${rockmanId}&msisdn%5B0%5D=${bupperMSISDN}&${additionalQueryString}${extraParamsQs}${search}`
// }


function _submitMSISDN() {
  _submitMSISDN = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(window, maybeConfig, internationalMSISDN, bupperMSISDN, strategy, extraParams) {
    var config;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            console.table([{
              internationalMSISDN: internationalMSISDN,
              bupperMSISDN: bupperMSISDN
            }]);
            config = strategy ? _objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, strategy.flowConfig) : _objectSpread(_objectSpread({
              offer: window.pac_analytics.visitor.offer
            }, getConfig()), maybeConfig || {});
            return _context2.abrupt("return", submitMSISDNWithConfig(window, config, internationalMSISDN, extraParams));

          case 3:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _submitMSISDN.apply(this, arguments);
}

function submitMSISDNWithConfig(_x7, _x8, _x9, _x10) {
  return _submitMSISDNWithConfig.apply(this, arguments);
}

function _submitMSISDNWithConfig() {
  _submitMSISDNWithConfig = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3(window, config, internationalMSISDN, extraParams) {
    var slug, country, device, offer, host, bupperizeCountry, search, extraParamsQs, msisdn, rockmanId, result, type, error;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            slug = config.slug, country = config.country, device = config.device, offer = config.offer, host = config.host;

            bupperizeCountry = function bupperizeCountry(c) {
              return c == 'gb' ? 'uk' : c;
            };

            search = window.location.search.substr(1) || '';
            extraParamsQs = !extraParams ? '' : '&' + Object.keys(extraParams).map(function (k) {
              return "".concat(k, "=").concat(extraParams[k]);
            }).join('&');
            msisdn = internationalMSISDN.match(/\d+/gi).join('');
            rockmanId = window.pac_analytics.visitor.rockmanId;
            _context3.next = 8;
            return fetch("https://".concat(host, "/tallyman/v1/?action=redirect&slug=").concat(slug, "&country=").concat(country, "&msisdn=").concat(msisdn, "&device=").concat(device, "&offerId=").concat(offer, "&rockman_id=").concat(rockmanId, "&page=").concat(window.location.href, "&pixel_url=").concat(encodeURIComponent("http://c1.ouisys.com/pixels?xcid=".concat(window.location.pathname.replace("/", ""), "&xaid=").concat(window.pac_analytics.visitor.xaid, "&country=").concat(bupperizeCountry(country)))).concat(search).concat(extraParamsQs)).then(function (x) {
              return x.json();
            });

          case 8:
            result = _context3.sent;

            if (!(false === result.success)) {
              _context3.next = 17;
              break;
            }

            type = result.message == 'ALREADY SUBSCRIBED' ? "AlreadySubscribed" : "InvalidMSISDN";
            error = new Error("".concat(type, ":\n").concat(result.message));
            error['type'] = type;
            console.error(error);
            throw error;

          case 17:
            return _context3.abrupt("return", result.redirect_url);

          case 18:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _submitMSISDNWithConfig.apply(this, arguments);
}

var getOrOverrideConfig = function getOrOverrideConfig(maybeConfig, strategy) {
  var config = strategy ? _objectSpread({}, strategy.flowConfig) : !maybeConfig ? {} : maybeConfig;

  var _getConfig = getConfig(),
      host = _getConfig.host,
      country = _getConfig.country,
      slug = _getConfig.slug,
      device = _getConfig.device,
      queryString = _getConfig.queryString;

  return {
    host: config.host || host,
    slug: config.slug || slug,
    country: config.country || country,
    device: config.device || device,
    queryString: (config.queryString || []).concat(queryString || [])
  };
};

var fetchJsonp = function fetchJsonp(_url) {
  var url = _url;
  var ouisys_callback_function = "ouisys_callback_function" + Math.floor(Math.random() * 10000);
  return new Promise(function (resolve, reject) {
    window[ouisys_callback_function] = function (arg) {
      resolve(arg);
    };

    url += url.indexOf('?') === -1 ? '?' : '&';
    url += "jsonp=".concat(ouisys_callback_function);
    var script = document.createElement("script");
    script.src = url;
    script.id = ouisys_callback_function;
    document.body.appendChild(script); // Caught if got 404/500

    script.onerror = function () {
      reject(new Error("JSONP request to ".concat(_url, " failed")));
    };
  });
};

var getRedirectUrl = /*#__PURE__*/function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(maybeConfig, extraParams, strategy) {
    var _getOrOverrideConfig, host, country, slug, queryString, device, bupperizeCountry, offer, rockmanId, s, search, extraParamsQs, url, result, identifyError;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            if (!(typeof window == "undefined")) {
              _context.next = 4;
              break;
            }

            throw "javascript: console.error('SSR'); void 6";

          case 4:
            _getOrOverrideConfig = getOrOverrideConfig(maybeConfig, strategy), host = _getOrOverrideConfig.host, country = _getOrOverrideConfig.country, slug = _getOrOverrideConfig.slug, queryString = _getOrOverrideConfig.queryString, device = _getOrOverrideConfig.device;

            bupperizeCountry = function bupperizeCountry(c) {
              return c == 'gb' ? 'uk' : c;
            };

            offer = window.pac_analytics.visitor.offer;
            rockmanId = window.pac_analytics.visitor.rockmanId;
            s = window.location.search.substr(1);
            search = (!!s && s.length > 0 ? [s] : []).concat((queryString || []).map(function (_ref2) {
              var _ref3 = _slicedToArray(_ref2, 2),
                  k = _ref3[0],
                  v = _ref3[1];

              return "".concat(k, "=").concat(v);
            })).join('&');
            extraParamsQs = !extraParams ? '' : '&' + Object.keys(extraParams).map(function (k) {
              return "".concat(k, "=").concat(extraParams[k]);
            }).join('&');
            url = "https://".concat(host, "/tallyman/v1/?action=identify-user&country=").concat(bupperizeCountry(country), "&slug=").concat(slug, "&device=").concat(device, "&offerId=").concat(offer, "&page=").concat(window.location.href, "&pixel_url=").concat(encodeURIComponent("http://c1.ouisys.com/pixels?xcid=".concat(window.location.pathname.replace("/", ""), "&xaid=").concat(window.pac_analytics.visitor.xaid, "&country=").concat(bupperizeCountry(country))), "&rockman_id=").concat(rockmanId).concat(extraParamsQs, "&").concat(search);
            _context.next = 14;
            return fetchJsonp(url);

          case 14:
            result = _context.sent;

            if (!(false === result.success)) {
              _context.next = 22;
              break;
            }

            identifyError = new Error("Error in getRedirectUrl() identify-user action:\n".concat(result.message));
            identifyError['type'] = "NotOn3g";
            identifyError['next_action'] = result.next_action;
            throw identifyError;

          case 22:
            return _context.abrupt("return", result.redirect_url);

          case 23:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));

  return function getRedirectUrl(_x11, _x12, _x13) {
    return _ref.apply(this, arguments);
  };
}();

exports.getRedirectUrl = getRedirectUrl;