"use strict";

require("core-js/modules/es6.regexp.match");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.matchMSISDNEntry = matchMSISDNEntry;
exports.match = match;
exports.default = exports.mockedCompletedState = exports.mockedMSISDNEntryFailure = exports.mockedMSISDNEntrySuccess = exports.initialState = void 0;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.reflect.construct");

require("core-js/modules/es6.object.set-prototype-of");

require("core-js/modules/es6.object.assign");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.object.keys");

require("regenerator-runtime/runtime");

var React = _interopRequireWildcard(require("react"));

var _main = _interopRequireWildcard(require("./main"));

var RDS = _interopRequireWildcard(require("../../common-types/RemoteDataState"));

var _MOLink = require("../common-components/MOLink");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var mkMOLink = function mkMOLink(tracker, keywordAndShortcode) {
  return function (_ref) {
    var children = _ref.children,
        keyword = _ref.keyword,
        shortcode = _ref.shortcode,
        props = _objectWithoutProperties(_ref, ["children", "keyword", "shortcode"]);

    var keywordAndShortcode1 = {
      keyword: keyword || keywordAndShortcode.keyword,
      shortcode: shortcode || keywordAndShortcode.shortcode
    };
    return /*#__PURE__*/React.createElement(_MOLink.MOLink, _extends({
      onClick: function onClick() {
        if (!tracker) {
          console.warn("tracker parameter is null in mkMOLink");
        } else {
          tracker.advancedInFlow("click2sms", "click", keywordAndShortcode1);
        }
      },
      keywordAndShortcode: keywordAndShortcode1
    }, props), children);
  };
};

var initialState = {
  type: "MSISDNEntry",
  result: RDS.NothingYet()
};
exports.initialState = initialState;
var mockedMSISDNEntrySuccess = {
  type: "MSISDNEntry",
  result: RDS.Success({
    keyword: 'TEST OK',
    shortcode: '666',
    MOLink: mkMOLink(null, {
      keyword: 'TEST OK',
      shortcode: '666'
    })
  })
};
exports.mockedMSISDNEntrySuccess = mockedMSISDNEntrySuccess;
var mockedMSISDNEntryFailure = {
  type: "MSISDNEntry",
  result: RDS.Failure({
    errorType: "InvalidMSISDN",
    error: "Invalid Mobile Number"
  })
};
exports.mockedMSISDNEntryFailure = mockedMSISDNEntryFailure;
var mockedCompletedState = {
  type: "Completed",
  result: void 6
};
exports.mockedCompletedState = mockedCompletedState;

function matchMSISDNEntry(m) {
  return RDS.match(m);
}

function match(_ref2) {
  var msisdnEntry = _ref2.msisdnEntry,
      completed = _ref2.completed;
  return function (state) {
    switch (state.type) {
      case 'MSISDNEntry':
        return msisdnEntry(state.result);

      case 'Completed':
        return completed(state.result);
    }
  };
}

var _default = function _default(tracker, Comp, strategy) {
  return function (initialState) {
    var _temp;

    var HOC = (_temp = /*#__PURE__*/function (_React$PureComponent) {
      _inherits(HOC, _React$PureComponent);

      var _super = _createSuper(HOC);

      function HOC(props) {
        var _this;

        _classCallCheck(this, HOC);

        _this = _super.call(this, props);

        _defineProperty(_assertThisInitialized(_this), "state", void 0);

        var self = _assertThisInitialized(_this);

        _this.state = {
          currentState: initialState,
          actions: {
            backToStart: function backToStart() {
              _this.setState({
                currentState: initialState
              });
            },
            submitMSISDN: function () {
              var _submitMSISDN2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                var _len,
                    args,
                    _key,
                    msisdn,
                    keywordAndShortcode,
                    moLink,
                    errorType,
                    _args = arguments;

                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        _this.setState({
                          currentState: {
                            type: "MSISDNEntry",
                            result: RDS.Loading()
                          }
                        });

                        for (_len = _args.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                          args[_key] = _args[_key];
                        }

                        msisdn = args[2];
                        tracker.advancedInFlow('tallyman.v1-mo', 'msisdn-submitted', {
                          msisdn: msisdn
                        });

                        if (strategy) {
                          args[3] = strategy;
                        }

                        _context.prev = 5;
                        _context.next = 8;
                        return _main.default.apply(void 0, args);

                      case 8:
                        keywordAndShortcode = _context.sent;
                        tracker.advancedInFlow('tallyman.v1-mo', 'msisdn-submission-success', {
                          msisdn: msisdn
                        });
                        moLink = mkMOLink(tracker, keywordAndShortcode);
                        self.setState({
                          currentState: {
                            type: "MSISDNEntry",
                            result: RDS.Success(_objectSpread(_objectSpread({}, keywordAndShortcode), {}, {
                              MOLink: moLink
                            }))
                          },
                          actions: _objectSpread({}, self.state.actions)
                        });
                        _context.prev = 12;

                        _main.checkSubscription.apply(void 0, args).then(function (product_url) {
                          tracker.advancedInFlow('tallyman.v1-mo', 'sale', {
                            msisdn: msisdn
                          });
                          setTimeout(function () {
                            window.location.href = product_url;
                          }, 1000);
                        });

                        _context.next = 19;
                        break;

                      case 16:
                        _context.prev = 16;
                        _context.t0 = _context["catch"](12);
                        throw _context.t0;

                      case 19:
                        _context.next = 26;
                        break;

                      case 21:
                        _context.prev = 21;
                        _context.t1 = _context["catch"](5);
                        errorType = "SEAlreadySubscribed" === _context.t1.type ? "AlreadySubscribed" : "SEInvalidMSISDN" == _context.t1.type ? "InvalidMSISDN" : "UnknownError";
                        self.setState({
                          currentState: {
                            type: "MSISDNEntry",
                            result: RDS.Failure({
                              errorType: errorType,
                              error: _context.t1
                            })
                          }
                        });
                        tracker.recedeInFlow('tallyman.v1-mo', 'msisdn-submission-failure', {
                          msisdn: msisdn,
                          errorType: errorType || 'UnknownError'
                        });

                      case 26:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, null, [[5, 21], [12, 16]]);
              }));

              function submitMSISDN() {
                return _submitMSISDN2.apply(this, arguments);
              }

              return submitMSISDN;
            }()
          }
        };
        return _this;
      }

      _createClass(HOC, [{
        key: "render",
        value: function render() {
          return /*#__PURE__*/React.createElement(Comp, _extends({}, this.props, {
            currentState: this.state.currentState,
            actions: this.state.actions,
            strategyConfig: strategy ? strategy : undefined
          }));
        }
      }]);

      return HOC;
    }(React.PureComponent), _temp);
    HOC.prototype['_client'] = "tallyman.v1-mo";
    return HOC;
  };
};

exports.default = _default;