import { IFlow } from "../super-strategy/HOC";
export declare type IConfig = {
    offer: number;
    slug?: string;
    country?: string;
    host?: string;
    device?: "smart" | "feature";
};
export declare type IMSISDNSubmissionResult = {
    success: true;
    rockman_id: string;
    redirect_url: string;
} | {
    success: false;
    rockman_id: string;
    message: string;
};
export declare const additionalQueryString = "msisdnSubmitted=Y&legalCheckbox=Y&incentivizedCheckbox=Y&op_confirmCheckbox=N";
export default function submitMSISDN(window: Window, maybeConfig: IConfig, internationalMSISDN: string, bupperMSISDN: string, strategy?: IFlow, extraParams?: {
    [key: string]: string;
}): Promise<string>;
export declare function submitMSISDNWithConfig(window: Window, config: IConfig, internationalMSISDN: string, bupperMSISDN: string, extraParams?: {
    [key: string]: string;
}): Promise<string>;
