"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

require("core-js/modules/es7.object.get-own-property-descriptors");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.keys");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

var path = _interopRequireWildcard(require("path"));

var fs = _interopRequireWildcard(require("fs"));

var R = _interopRequireWildcard(require("ramda"));

var _inquirer = _interopRequireDefault(require("inquirer"));

var envfile = _interopRequireWildcard(require("envfile"));

var _axios = _interopRequireDefault(require("axios"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

var env = envfile.parseFileSync(path.resolve("", '.env'));

function _default(_x) {
  return _ref.apply(this, arguments);
}

function _ref() {
  _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(page_type) {
    var result, data, countries, _yield$inquirer$promp, country, scenarios, _yield$inquirer$promp2, scenarioService, scenario, service, updatedEnvContent;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return (0, _axios.default)({
              url: 'http://c1.ouisys.com/api/v1/get-config',
              //url:'http://localhost:3030/api/v1/get-page-legals',
              method: 'get',
              params: {
                client: page_type
              }
            });

          case 2:
            result = _context.sent;
            data = result.data; //const dataKeys = Object.keys(options);
            // const countries = R.pipe(
            //   R.map((o: any) => options[o].config.country as string),
            //   R.uniq,
            //   R.sortBy(x => x),
            //   xs => (!!env.country ? [env.country] : []).concat(xs)
            // )(dataKeys)

            countries = R.pipe(R.map(function (o) {
              return o.country;
            }), R.uniq, R.sortBy(function (x) {
              return x;
            }), function (xs) {
              return (!!env.country ? [env.country] : []).concat(xs);
            })(data);
            console.log("You are configuring '".concat(page_type, "' template.")); // first choose a country

            _context.next = 8;
            return _inquirer.default.prompt([{
              type: "list",
              name: "country",
              message: "First select a country. ".concat(env.country ? "Current country: ".concat(env.country) : ''),
              choices: countries.map(function (c) {
                return {
                  name: c,
                  value: c
                };
              })
            }]);

          case 8:
            _yield$inquirer$promp = _context.sent;
            country = _yield$inquirer$promp.country;
            scenarios = R.pipe(R.filter(function (x) {
              return x.country == country;
            }))(data);
            _context.next = 13;
            return _inquirer.default.prompt([{
              type: "list",
              name: "scenarioService",
              message: "Now select a scenario for ".concat(country),
              choices: scenarios.map(function (s) {
                return {
                  name: "(SCENARIO:".concat(s.scenario, " & SERVICE:").concat(s.service, ") - ").concat(s.host, "/").concat(s.country, "/").concat(s.scenario),
                  value: s
                };
              })
            }]);

          case 13:
            _yield$inquirer$promp2 = _context.sent;
            scenarioService = _yield$inquirer$promp2.scenarioService;
            scenario = scenarioService.scenario;
            service = scenarioService.service;
            updatedEnvContent = envfile.stringifySync(_objectSpread(_objectSpread({}, env), {}, {
              country: country,
              scenario: scenario,
              service: service
            }));
            fs.writeFileSync(path.resolve("", ".env"), updatedEnvContent, "utf8");
            fs.writeFileSync(path.resolve("", "config.json"), JSON.stringify({
              automaticallySubmitAllOperators: scenarioService.automatically_submit_all_operators !== null ? scenarioService.automatically_submit_all_operators : false,
              country: country,
              device: scenarioService.device,
              host: scenarioService.host,
              slug: scenario,
              operators: scenarioService.operators ? scenarioService.operators : [],
              service: service,
              queryString: scenarioService.query_string ? scenarioService.query_string : undefined,
              apiAction: scenarioService.api_action !== null ? scenarioService.api_action : undefined
            }, null, 2), "utf8");
            console.table([{
              country: country,
              scenario: scenario,
              service: service
            }]);

          case 21:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _ref.apply(this, arguments);
}