"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.weak-map");

require("core-js/modules/es7.array.includes");

var path = _interopRequireWildcard(require("path"));

var envfile = _interopRequireWildcard(require("envfile"));

var _configurePageStrategy = _interopRequireDefault(require("./configure-page-strategy"));

var _configurePageScenario = _interopRequireDefault(require("./configure-page-scenario"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var env = envfile.parseFileSync(path.resolve("", '.env'));
var client = env.client;
var strategyBasedClients = ["super-strategy"];
var scenarioBasedClients = ["assrock-mo", "assrock-pin", "bupper-click2sms", "bupper-one-click", "tallyman.v1-pin", "tola-mpesa", "tallyman.v1-moredir", "tallyman.v1-mo", "tallyman.v1-click2sms", "tallyman.v1-one-click", "tallyman.v1-click-redir"];

if (!!client) {
  if (strategyBasedClients.includes(client)) {
    (0, _configurePageStrategy.default)(client).then(function (res) {
      console.log("res");
    }).catch(function (err) {
      console.log("err", err);
    });
  }

  if (scenarioBasedClients.includes(client)) {
    console.log("");
    (0, _configurePageScenario.default)(client).then(function (res) {
      console.log("res");
    }).catch(function (err) {
      console.log("err", err);
    });
  }
} else {
  throw "Please specify a client in .env file.";
}