"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

require("core-js/modules/es6.array.iterator");

require("core-js/modules/es6.weak-map");

require("core-js/modules/es6.object.freeze");

require("core-js/modules/es6.regexp.to-string");

require("core-js/modules/es6.string.iterator");

require("core-js/modules/es6.array.from");

require("core-js/modules/web.dom.iterable");

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/es6.regexp.split");

require("regenerator-runtime/runtime");

require("core-js/modules/es6.promise");

require("core-js/modules/es6.object.to-string");

require("core-js/modules/es6.function.name");

require("core-js/modules/es6.array.find");

var _ramda = _interopRequireDefault(require("ramda"));

var _tsSimpleAst = _interopRequireWildcard(require("ts-simple-ast"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _locales = _interopRequireDefault(require("./locales.json"));

var inquirer = _interopRequireWildcard(require("inquirer"));

var _glob = _interopRequireDefault(require("glob"));

var _translateByYandex = require("./translate-by-yandex");

var _tinyAsyncPool = _interopRequireDefault(require("tiny-async-pool"));

var _dedentJs = _interopRequireDefault(require("dedent-js"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _templateObject3() {
  var data = _taggedTemplateLiteral(["\u2611\uFE0F addLocaleData.ts file updated:\n  -----\n  ", "\n  ----"]);

  _templateObject3 = function _templateObject3() {
    return data;
  };

  return data;
}

function _templateObject2() {
  var data = _taggedTemplateLiteral(["JSON files for these languages are missing.\n           ", "\n        Select an option to proceed:"]);

  _templateObject2 = function _templateObject2() {
    return data;
  };

  return data;
}

function _templateObject() {
  var data = _taggedTemplateLiteral(["Are you sure you want to \n          + add    ", "\n          - remove ", "\n      and modify page?\n      "]);

  _templateObject = function _templateObject() {
    return data;
  };

  return data;
}

function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

// -- UI functions:
var entryPath = "./src";

function selectLocales(_x) {
  return _selectLocales.apply(this, arguments);
}

function _selectLocales() {
  _selectLocales = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(currentLocales) {
    var _ref, locales, confirm;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return inquirer.prompt([{
              type: "checkbox",
              name: "locales",
              message: "Which locales do you want to support?",
              choices: _ramda.default.toPairs(_locales.default).map(function (_ref2) {
                var _ref3 = _slicedToArray(_ref2, 2),
                    key = _ref3[0],
                    l = _ref3[1];

                return {
                  name: "".concat(l.name, " (").concat(key, ")"),
                  value: key,
                  checked: currentLocales.some(function (c) {
                    return c == key;
                  })
                };
              }),
              validate: function validate(locales) {
                return locales.some(function (l) {
                  return l == 'en';
                }) ? true : '🇬🇧  You must select English!';
              }
            }, {
              type: "confirm",
              name: "confirm",
              message: function message(_ref4) {
                var locales = _ref4.locales;
                var newLangs = locales.filter(function (l) {
                  return !currentLocales.some(function (c) {
                    return c == l;
                  });
                });
                var delLangs = currentLocales.filter(function (c) {
                  return !locales.some(function (l) {
                    return c == l;
                  });
                });
                return (0, _dedentJs.default)(_templateObject(), newLangs.length == 0 ? '(No new languages)' : newLangs.map(function (l) {
                  return "".concat(_locales.default[l].name, " (").concat(l, ")");
                }).join(' and '), delLangs.length == 0 ? '(Nothing)' : delLangs.map(function (l) {
                  return "".concat(_locales.default[l].name, " (").concat(l, ")");
                }).join(' and '));
              }
            }]);

          case 2:
            _ref = _context.sent;
            locales = _ref.locales;
            confirm = _ref.confirm;

            if (confirm) {
              _context.next = 9;
              break;
            }

            return _context.abrupt("return", selectLocales(currentLocales));

          case 9:
            console.log('☑️ selectLocales() completed.');
            return _context.abrupt("return", locales);

          case 11:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _selectLocales.apply(this, arguments);
}

function handleMissingTranslations(_x2) {
  return _handleMissingTranslations.apply(this, arguments);
}

function _handleMissingTranslations() {
  _handleMissingTranslations = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee2(localesWithMissingTranslations) {
    var _ref5, translationOption, result;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            if (!(localesWithMissingTranslations.length > 0)) {
              _context2.next = 18;
              break;
            }

            _context2.next = 3;
            return inquirer.prompt([{
              type: "list",
              name: "translationOption",
              message: (0, _dedentJs.default)(_templateObject2(), localesWithMissingTranslations.map(function (l) {
                return "".concat(_locales.default[l].name, " (").concat(l, ")");
              }).join(', ')),
              choices: [{
                name: 'Just clonse en.json.',
                value: 'fromEn',
                checked: true
              }, {
                name: 'Use Yandex to translate en.json.',
                value: 'yandex'
              }]
            }]);

          case 3:
            _ref5 = _context2.sent;
            translationOption = _ref5.translationOption;
            _context2.next = 7;
            return translationOption;

          case 7:
            _context2.t0 = _context2.sent;

            if (!(_context2.t0 == "fromEn")) {
              _context2.next = 12;
              break;
            }

            _context2.t1 = createTranslationJSONFilesFromEN(localesWithMissingTranslations);
            _context2.next = 13;
            break;

          case 12:
            _context2.t1 = translate(localesWithMissingTranslations);

          case 13:
            result = _context2.t1;
            console.log('☑️ handleMissingTranslations() completed.');
            return _context2.abrupt("return", result);

          case 18:
            console.log('☑️ All selected languages already have a JSON file.');
            return _context2.abrupt("return", []);

          case 20:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2);
  }));
  return _handleMissingTranslations.apply(this, arguments);
}

function main() {
  return _main.apply(this, arguments);
} // -- lib functions:


function _main() {
  _main = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
    var _processPage, currentLocales, sourceFile, localeStatements, locales, localesWithMissingTranslations, updatedLocaleFile;

    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            _processPage = processPage(), currentLocales = _processPage.currentLocales, sourceFile = _processPage.sourceFile, localeStatements = _processPage.localeStatements;
            _context3.next = 3;
            return selectLocales(currentLocales);

          case 3:
            locales = _context3.sent;
            _context3.next = 6;
            return getLocalesWithMissingTranslationJSONFiles(locales);

          case 6:
            localesWithMissingTranslations = _context3.sent;
            _context3.next = 9;
            return handleMissingTranslations(localesWithMissingTranslations);

          case 9:
            _context3.next = 11;
            return modifyAddLocaleDataFile(sourceFile, currentLocales, locales, localeStatements);

          case 11:
            updatedLocaleFile = _context3.sent;
            console.log((0, _dedentJs.default)(_templateObject3(), updatedLocaleFile.split('\n').map(function (x) {
              return "     ".concat(x);
            }).join('\n')));
            return _context3.abrupt("return", "\n\u2705 ".concat(locales.join(', '), " locales have been updated succesfully \n\uD83D\uDE0A"));

          case 14:
          case "end":
            return _context3.stop();
        }
      }
    }, _callee3);
  }));
  return _main.apply(this, arguments);
}

function getLocalesWithMissingTranslationJSONFiles(_x3) {
  return _getLocalesWithMissingTranslationJSONFiles.apply(this, arguments);
}

function _getLocalesWithMissingTranslationJSONFiles() {
  _getLocalesWithMissingTranslationJSONFiles = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee4(locales) {
    var toPromise, root, files, missingLocaleJSONS;
    return regeneratorRuntime.wrap(function _callee4$(_context4) {
      while (1) {
        switch (_context4.prev = _context4.next) {
          case 0:
            toPromise = function toPromise(f) {
              return function () {
                for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
                  args[_key] = arguments[_key];
                }

                return new Promise(function (resolve, reject) {
                  f.apply(void 0, args.concat([function (err, res) {
                    return !!err ? reject(err) : resolve(res);
                  }]));
                });
              };
            };

            root = entryPath;
            _context4.next = 4;
            return toPromise(_glob.default)(_path.default.resolve(root, "localization/translations/*.json"), {});

          case 4:
            files = _context4.sent;
            missingLocaleJSONS = locales.filter(function (l) {
              return !_ramda.default.contains(l, files.map(function (f) {
                return _path.default.basename(f).split('.')[0];
              }));
            });
            return _context4.abrupt("return", missingLocaleJSONS);

          case 7:
          case "end":
            return _context4.stop();
        }
      }
    }, _callee4);
  }));
  return _getLocalesWithMissingTranslationJSONFiles.apply(this, arguments);
}

function createTranslationJSONFilesFromEN(_x4) {
  return _createTranslationJSONFilesFromEN.apply(this, arguments);
}

function _createTranslationJSONFilesFromEN() {
  _createTranslationJSONFilesFromEN = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee5(locales) {
    var root, en;
    return regeneratorRuntime.wrap(function _callee5$(_context5) {
      while (1) {
        switch (_context5.prev = _context5.next) {
          case 0:
            root = entryPath;
            en = require(_path.default.resolve(root, "localization/translations/en.json"));
            locales.forEach(function (l) {
              var content = JSON.stringify(_ramda.default.map(function (v) {
                return "".concat(l, ":: ").concat(v);
              })(en), null, 2);

              var filePath = _path.default.resolve(root, "localization/translations/".concat(l, ".json"));

              _fs.default.writeFileSync(filePath, content, 'utf8');

              console.log("Created: ".concat(filePath));
            });
            return _context5.abrupt("return", locales);

          case 4:
          case "end":
            return _context5.stop();
        }
      }
    }, _callee5);
  }));
  return _createTranslationJSONFilesFromEN.apply(this, arguments);
}

function translate(_x5) {
  return _translate.apply(this, arguments);
} // -- AST functions:


function _translate() {
  _translate = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee7(locales) {
    var root, en, result;
    return regeneratorRuntime.wrap(function _callee7$(_context7) {
      while (1) {
        switch (_context7.prev = _context7.next) {
          case 0:
            root = entryPath;
            en = require(_path.default.resolve(root, "localization/translations/en.json"));
            _context7.next = 4;
            return (0, _tinyAsyncPool.default)(1, locales, /*#__PURE__*/function () {
              var _ref6 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee6(l) {
                var translation, content, filePath;
                return regeneratorRuntime.wrap(function _callee6$(_context6) {
                  while (1) {
                    switch (_context6.prev = _context6.next) {
                      case 0:
                        _context6.next = 2;
                        return (0, _translateByYandex.translateHash)('en', l, en);

                      case 2:
                        translation = _context6.sent;
                        content = JSON.stringify(translation, null, 2);
                        filePath = _path.default.resolve(root, "localization/translations/".concat(l, ".json"));

                        _fs.default.writeFileSync(filePath, content, 'utf8');

                        console.log("Created: ".concat(filePath));
                        return _context6.abrupt("return", l);

                      case 8:
                      case "end":
                        return _context6.stop();
                    }
                  }
                }, _callee6);
              }));

              return function (_x6) {
                return _ref6.apply(this, arguments);
              };
            }());

          case 4:
            result = _context7.sent;
            return _context7.abrupt("return", result);

          case 6:
          case "end":
            return _context7.stop();
        }
      }
    }, _callee7);
  }));
  return _translate.apply(this, arguments);
}

function processPage() {
  var ast = new _tsSimpleAst.default();
  var sourceFile = ast.addExistingSourceFile("./src/localization/addLocaleData.ts");

  var processImportDecleration = function processImportDecleration(s) {
    var lit = s.getModuleSpecifier().getLiteralValue();

    var tryMatch = function tryMatch(regex) {
      var match = regex.exec(lit);
      return !!match ? match[1] : null;
    };

    var locale = tryMatch(/react\-intl\/locale\-data\/(\w\w)/gm) || tryMatch(/\/translations\/(\w\w).json/);
    var name = s.getImportClause().getText();

    if (!!locale) {
      return {
        module: lit,
        name: name,
        locale: locale,
        s: s,
        kind: _tsSimpleAst.SyntaxKind.ImportDeclaration
      };
    } else {
      return {
        module: lit,
        name: name,
        s: s,
        kind: _tsSimpleAst.SyntaxKind.ImportDeclaration
      };
    }
  };

  var processExpression = function processExpression(s, imports) {
    return s.getExpression().getKind() == _tsSimpleAst.SyntaxKind.CallExpression ? processCallExpression(s, s.getExpression(), imports) : null;
  };

  var processCallExpression = function processCallExpression(s, p, imports) {
    var args = p.getArguments().map(function (a) {
      return a.getText();
    });
    var fn = p.getExpression().getText();
    var localeImpprt = imports.find(function (i) {
      return !!i.locale && args.some(function (a) {
        return a == i.name;
      });
    });
    return !!localeImpprt ? {
      fn: fn,
      args: args,
      locale: localeImpprt.locale,
      s: s
    } : {
      fn: fn,
      args: args,
      s: s
    };
  };

  var processExportDecleration = function processExportDecleration(s, imports) {
    var names = s.getNamedExports().map(function (n) {
      return n.getText();
    });
    return names.length == 1 && imports.some(function (i) {
      return i.name == names[0];
    }) ? {
      exports: names,
      locale: names[0],
      s: s
    } : {
      exports: names,
      s: s
    };
  };

  var statements = sourceFile.getStatements();
  var importStatements = statements.filter(function (s) {
    return s.getKind() == _tsSimpleAst.SyntaxKind.ImportDeclaration;
  }).map(function (s) {
    return processImportDecleration(s);
  }).filter(function (s) {
    return !!s && !!s.locale;
  });
  var exportStatements = statements.filter(function (s) {
    return s.getKind() == _tsSimpleAst.SyntaxKind.ExportDeclaration;
  }).map(function (s) {
    return processExportDecleration(s, importStatements);
  }).filter(function (s) {
    return !!s && !!s.locale;
  });
  var callStatements = statements.filter(function (s) {
    return s.getKind() == _tsSimpleAst.SyntaxKind.ExpressionStatement;
  }).map(function (s) {
    return processExpression(s, importStatements);
  }).filter(function (s) {
    return !!s && !!s.locale;
  });
  var localeStatements = [].concat(_toConsumableArray(importStatements), _toConsumableArray(exportStatements), _toConsumableArray(callStatements));

  var currentLocales = _ramda.default.uniq(localeStatements.map(function (l) {
    return l.locale;
  }));

  return {
    currentLocales: currentLocales,
    sourceFile: sourceFile,
    localeStatements: localeStatements
  };
}

function modifyAddLocaleDataFile(sourceFile, currentLocales, localesToSupport, localeStatements) {
  var missingLocales = localesToSupport.filter(function (s) {
    return !currentLocales.some(function (l) {
      return l == s;
    });
  });

  function isPackageInstalled(packageName) {
    try {
      _fs.default.accessSync("./node_modules/".concat(packageName));

      return true;
    } catch (err) {
      return false;
    }
  } // add missing langs


  missingLocales.forEach(function (lang) {
    if (isPackageInstalled("react-intl")) {
      sourceFile.addImportDeclaration({
        defaultImport: "".concat(lang, "LocaleData"),
        moduleSpecifier: "react-intl/locale-data/".concat(lang)
      });
      sourceFile.addStatements("addLocaleData(".concat(lang, "LocaleData);"));
    }

    sourceFile.addImportDeclaration({
      defaultImport: lang,
      moduleSpecifier: "./translations/".concat(lang, ".json")
    });
    sourceFile.addStatements("export {".concat(lang, "};"));
  }); // remove extea langs

  localeStatements.forEach(function (s) {
    if (!localesToSupport.some(function (l) {
      return l == s.locale;
    })) {
      s.s.remove();
    }
  });
  sourceFile.formatText();
  sourceFile.saveSync();
  return sourceFile.getText();
}

main().then(console.log).catch(console.error);