import { IFlowEvent, IPacman } from "./types";
import IVisitor from "../common-types/IVisitor";
export declare class Pacman implements IPacman {
    private flow_event;
    private custom;
    private flowEventNumber;
    private batch;
    rockmanId: string;
    impressionNumber: number;
    startTime: number;
    readonly serverUrl: string;
    private d;
    private w;
    constructor(w: Window, visitor: IVisitor, startTime: number);
    initInteractions(): void;
    sendPageview(): void;
    sendFlowEvent(flowEvent: IFlowEvent): void;
    sendCustomEvent(typeName: string, eventName: string): void;
    getRelativeTime(): number;
}
