import {IPacman, IPacmanAnalytics} from "../pacman/types";

declare global {
  interface Event {
    accelerationIncludingGravity: {
      x: number;
      y: number;
      z: number;
    };
  }

  interface Navigator {
    connection: any;
    userLanguage: any;
    browserLanguage: any;
    systemLanguage: any;
    oscpu: any;
  }

export interface OuisysCallBackResponse {
  subscription_url: string;
  success:          boolean;
  rockman_id:       string;
}

  interface Window {
    openDatabase: any;
    pac_analytics?: IPacmanAnalytics;
    pacman?: IPacman;
    dataLayer: {
      push: (...args) => void
    };
    requestIdleCallback? : (...args) => void;
    google_optimize?: { get: (exprId: string) => string }
    "x-requested-with":string;
    evina_special_gateway:string;
    ouisys_callback_functionResponse:OuisysCallBackResponse
  }
  
  function gtag(...args): void;
}
