import manageTranslations from "react-intl-translations-manager";
import path from "path";
import  { exec } from "child_process";
import { async } from "rxjs/internal/scheduler/async";

const execute = (command, callback)=>{
  exec(command, (error, stdout, stderr) => callback(stdout));
};

execute(`echo "{}" > ./src/localization/translations/en.json`, async(res)=>{
  manageTranslations({
    messagesDirectory: 'src/localization/extractedMessages',
    translationsDirectory: 'src/localization/translations',
    languages: ['en'], // any language you need
    singleMessagesFile: true
  });
  console.log(`😇 Messages extracted to  ${path.resolve("","src/localization/translations/en.json")}`);
})

// manageTranslations({
//   messagesDirectory: 'src/localization/extractedMessages',
//   translationsDirectory: 'src/localization/translations',
//   languages: ['en'], // any language you need
//   singleMessagesFile: true
// });